<template>
    <div class="page-container settings">
        <div class="d-flex align-items-center justify-content-between">
            <Tabs
                :items="tabs"
                size="big"
                @switch="switchTab"
            />
            <b-button
                v-if="$route.query.tab !== 'push'"
                class="btn_save"
                :disabled="!isChanges"
                variant="primary"
                @click="update()"
            >
                Save
            </b-button>
        </div>
        <div
            class="content_wrapper"
            :class="{'loading-md': loading}"
        >
            <div
                v-if="isChanges"
                class="warn text-danger"
            >
                *please save the changes
            </div>
            <component
                :is="activeTab"
                v-if="settings"
                ref="item"
                :settings="settings[activeTab]"
                @save="save"
                @saveFromEmail="saveFromEmail"
                @saveSwitch="update($event)"
            />
        </div>
        <ModalConfirm
            :show="showModalConfirm"
            title="Are you sure?"
            class="modal_confirm"
            desc="Are you sure to leave this page before you saved the changes?"
            button-confirm="Save"
            button-cancel="Don`t save"
            @close="closeModalConfirm($event)"
            @confirm="confirmSave"
        />
    </div>
</template>

<script>
import Tabs from "@/components/elements/Tabs";
import Sms from "@/components/settings/tabs/Sms";
import Email from "@/components/settings/tabs/Email";
import Push from "@/components/settings/tabs/Push";
import api from '@/services/settings.service.js'
import shop from '@/mixins/shop.service'
import ModalConfirm from '@/components/testing-elements/pricing/ModalConfirm'

export default {
    components: {Tabs, Sms, Email, Push, ModalConfirm},
    mixins: [shop],
    beforeRouteLeave(to, from, next) {
      if(this.isChanges) {
        this.showModalConfirm = true
        this.redirect = to
        return
      }
      next()
    },
    data() {
        return {
            tabs: [
                {title: 'SMS', component: 'sms'},
                {title: 'Email', component: 'email'},
                {title: 'Push', component: 'push'},
            ],
            activeTab: 'sms',
            settings: null,  
            loading: true, 
            isChanges: false, 
            firstLoad: 0,
            showModalConfirm: false,
            redirect: null,
            changedItems: {},
            changedKeys: [],
        }
    },
    created() {
        this.getData()
        this.getShop(true)
    },
    methods: {
        async switchTab(num) {
            if(this.settings && this.$refs.item.save) await this.$refs.item.save({type: 'changeTab'})
            this.activeTab = this.tabs[num].component
            if(this.$route.query.tab !== this.activeTab) this.$router.replace({name: 'setting', query: {tab: this.activeTab}})
            if(!this.firstLoad) this.firstLoad = true
        },
        async confirmSave() {
          this.closeModalConfirm()
          await this.update()
          this.isChanges = false 
          this.redirect = null
        },
        switchUpdate() {

        },
        async save(data) {
            const {items} = data
            

            if(!data.type && !this.firstLoad) this.isChanges = true
            if(this.firstLoad) {
              setTimeout(() => {
                this.firstLoad = false
              }, 100)
            }
            // this.changedItems = {}
            for(const key in items) {
              if(typeof items[key] === 'object') {
                  if(items.hasOwnProperty('value')) this.settings[this.activeTab][key].value = items[key].value
                  else if(items.hasOwnProperty('from')) {
                      this.settings[this.activeTab][key].from = items[key].from
                      this.settings[this.activeTab][key].to = items[key].to
                  }

                  if (items.hasOwnProperty('isActive')) this.settings[this.activeTab][key].isActive = items[key].isActive

              } else this.settings[this.activeTab][key] = items[key]
            }
        },
        async update(value) {
          this.loading = true
          const prevValueChanges = this.isChanges
          await this.$refs.item.save()
          if(value && !prevValueChanges) this.isChanges = false
          const {type, key} = value || {}

          const payload = value ? {
            [type]: {
              [key]: this.settings[type][key]
            }
          } : JSON.parse(JSON.stringify(this.settings))

          
          if(type && !payload[type][key].isActive) {
            if(payload[type][key].hasOwnProperty('from')) payload[type][key] = {from: null, to: null, isActive: false}
            else payload[type][key].value = null
          }
          if(payload.sms) delete payload.sms.listTimeZones
          
          const data = await api.updateSetting(payload)
          if(data) {
            this.getShop(true)
            if(!value && prevValueChanges) this.isChanges = false
            this.loading = false
            
            let title = 'Changes saved'
            if(value && payload[type][key].isActive) title = `${value.name} enabled`
            if(value && !payload[type][key].isActive) title = `${value.name} disabled`

            this.$notify({
              type: 'success',
              title
            });
          }
         
        },
        async getData() {
            this.settings = await api.getSetting()

            this.settings.sms.listTimeZones.map(el => {
              const value = el.value
              const match = '&amp;'
              if(value.includes(match)) el.value = this.$formatter.stringReplace(value, match, '&')
              return el
            })

            this.copySettings = JSON.parse(JSON.stringify(this.settings))
            this.loading = false
        },
        async saveFromEmail(items) {
          await this.save({items})
          await this.update()
          this.$refs.item.clearLoads()
        },
        closeModalConfirm(event) {
          console.log(event, 'event')
          this.showModalConfirm = false
          if(event)  {
            this.isChanges = false
            this.$router.push(this.redirect.path)
          }
          this.redirect = null
        }
    }
}
</script>

<style lang="scss" scoped>
.page-container {
  padding-top: 42px;
}
.content-wrapper {
  position: relative;
  margin-top: 32px;
}
.content_wrapper {
  position: relative;
}
.btn_save.btn {
  margin-bottom: 5px;
  padding: 13px 34px;
  @media (max-width: 1010px) {
    padding: 13px 34px;
  }
  @media (max-width: 550px) {
    padding: 5px 17px;
  }
}
.loading-xs:after, .loading-sm:after, .loading-md:after, .loading-lg:after {
  top: 100px;
}
.warn {
  position: absolute;
  right: 7px;
  top: 7px;
  font-size: 12px;
}
</style>


<style lang="scss">
.modal_confirm {
  .btn {
    margin-top: 14px;
  }
  .close-container {
    .btn {
      margin-top: 0;
    }
  }
  .desc {
    font-size: 13px;
    width: 90%;
    text-align: center;
  }
}
.settings {
  .form-check-input {
        margin-top: 1.5px;
  } 
}
</style>